# -*- coding: utf-8 -*-
from __future__ import print_function
from __future__ import unicode_literals
#from __future__ import absolute_import
from __future__ import division

import os
import sys
import codecs

DEFAULT_ENCODING = "UTF-8"

def __is_python2():
    if sys.version_info.major != 2:
        return False
    return True

def __init():
    os.environ["LC_ALL"] = "ja_JP.UTF-8"

    if __is_python2():
        reload(sys)
        sys.setdefaultencoding(DEFAULT_ENCODING)
        sys.stdin = codecs.getreader("utf-8")(sys.stdin)
        sys.stdout = codecs.getwriter("utf-8")(sys.stdout)
        sys.stderr = codecs.getwriter("utf-8")(sys.stderr)
        return

    sys.stdin = codecs.getreader("utf-8")(sys.stdin.detach())
    sys.stdout = codecs.getwriter("utf-8")(sys.stdout.detach())
    sys.stderr = codecs.getwriter("utf-8")(sys.stderr.detach())

def __to_str(maybe_bytes):
    if maybe_bytes == None:
        return None
    return maybe_bytes.decode(DEFAULT_ENCODING)

def __to_bytes(maybe_str):
    if maybe_str == None:
        return None
    return maybe_str.encode(DEFAULT_ENCODING)

def __to_fspath(path):
    return __to_bytes(path)

def __makedirs(dir_path, exist_ok=False):
    if exist_ok and os.path.isdir(__to_fspath(dir_path)):
        return True
    return os.makedirs(__to_fspath(dir_path))
