# -*- coding: utf-8 -*-
from __future__ import print_function
from __future__ import unicode_literals
#from __future__ import absolute_import
from __future__ import division

import os
import stat
import fcntl
from compat import __to_fspath as compat_to_fspath
from sudo import __touch as sudo_touch

class FileLocker:
    lockfile = None
    def __init__(self, lockfile_path, lock=False):
        if not os.path.exists(compat_to_fspath(lockfile_path)):
            sudo_touch(lockfile_path)
        self.lockfile = open(compat_to_fspath(lockfile_path), "r+")
        if lock:
            self.lock()

    def try_lock(self):
        try:
            fcntl.flock(self.lockfile.fileno(), fcntl.LOCK_EX|fcntl.LOCK_NB)
        except:
            return False
        return True

    def lock(self):
        fcntl.flock(self.lockfile.fileno(), fcntl.LOCK_EX)

    def unlock(self):
        fcntl.flock(self.lockfile.fileno(), fcntl.LOCK_UN)

    def read(self):
        return self.lockfile.read()

    def write(self, data):
        self.lockfile.truncate()
        self.lockfile.write(data)

    def __del__(self):
        if self.lockfile:
            self.unlock()
            self.lockfile.close()

