# -*- coding: utf-8 -*-
from __future__ import print_function
from __future__ import unicode_literals
#from __future__ import absolute_import
from __future__ import division

import os
import sys
import subprocess as sp
from compat import __to_bytes, __to_fspath

SUDO_CMD = "/usr/bin/sudo"

def __exec_cmd(args):
    if os.getuid() != 0:
        args = [SUDO_CMD] + args
    #print(str(args), file=sys.stderr)
    args = [__to_bytes(a) for a in args]
    proc = sp.Popen(args, stdout=sp.PIPE, stderr=sp.PIPE)
    outs, errs = proc.communicate()
    #print(str(outs), file=sys.stderr)
    return proc.returncode, outs

def __touch(path, mode=0o666):
    returncode, outs = __exec_cmd(["install",
                                   "-m", oct(mode), "-o", "root", "-g", "root",
                                   "/dev/null", path])
    if returncode != 0:
        return False
    return True

def __rmtree(path):
    returncode, outs = __exec_cmd(["rm", "-r", path])
    if returncode != 0:
        return False
    return True

def __makedirs(dir_path, exist_ok=False, mode=0o777):
    if exist_ok and os.path.isdir(__to_fspath(dir_path)):
        return True
    returncode, outs = __exec_cmd(["mkdir", "-m", oct(mode), "-p", dir_path])
    if returncode != 0:
        return False
    return True

def __copytree(source, destination):
    returncode, outs = __exec_cmd(["cp", "-a", source, destination])
    if returncode != 0:
        return False
    return True

