# -*- coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from __future__ import print_function
from __future__ import unicode_literals
from __future__ import absolute_import
from __future__ import division

from fal_msginfo import Msg
from fal_info import Results
from product_conf import SUDO_CMD
from ionas.request import Request, Entry, EntryList, XmlConfNode
from fal_info import FAL_MESSAGES_PATH, FAL_EVENTLOG_PATH


_EMPTY = object()


def gettext(constname, arglist={}, default=_EMPTY, do_log=True):
    try:
        if do_log: logging(constname, arglist=arglist)
        code = getattr(Msg, constname)
        entry = Entry('query', """<messages>
            <messageinfo>
                <code />
                <arglist />
            </messageinfo>
        </messages>""")
        messages_node = entry.get()
        code_node = messages_node.get_node('messageinfo/code')
        code_node.set_text(code)
        arglist_node = messages_node.get_node('messageinfo/arglist')
        for k, v in arglist.iteritems():
            arglist_node.append_child('arg', text=v, attrs={'name': k})
        request = Request(FAL_MESSAGES_PATH, filter_cmd=SUDO_CMD)
        response = request.request(entry)
        entry = response.get_entrylist().get_entry()
        return entry.get().get_value('messageinfo/message', '')
    except:
        if default is _EMPTY:
            raise
        return default


def logging(constname, arglist={}):
    try:
        code = getattr(Msg, constname)
        entry = Entry(
            'add',
            '<eventlog><log><code/><arglist/></log></eventlog>',
        )
        log_node = entry.get()
        code_node = log_node.get_node('log/code')
        code_node.set_text(code)
        arglist_node = log_node.get_node('log/arglist')
        for k, v in arglist.iteritems():
            arglist_node.append_child('arg', text=v, attrs={'name': k})
        request = Request(FAL_EVENTLOG_PATH, filter_cmd=SUDO_CMD)
        response = request.request(entry)
        entry = response.get_entrylist().get_entry()
        return entry.get_result() in (Results.OK,)
    except:
        return False
